<template>
  <abeuni-form
    class="registered-list"
    title="Lista de Cadastrados"
    subtitle="Lista dos cadastros realizados"
  >
    <vue-fuse
      :keys="config.search_keys"
      :list="registered"
      :placeholder="`Search from ${registered.length} entries`"
      @fuseResultsUpdated="search"
    />
    <modal :title="(modalData && modalData.fullname) || 'Error'" v-model="infoModal">
      <div v-if="infoModal" class="info-modal-content">
        <h3>Dados Pessoais</h3>
        <h4>Sexo</h4>
        {{ modalData.sex === "male" ? "M" : "F" }}
        <h4>Idade</h4>
        {{ modalData.age }}
        <h4>
          Documento
          <br />
          [ {{ modalData.document.type === 'other' && `${modalData.document.other_type}` || modalData.document.type }} ]
        </h4>
        {{ modalData.document.value }}
        <h4>Estado civil</h4>
        {{ modalData.civil_status.name }}
        <h4>Endereço</h4>
        {{
        `${modalData.address.street}, ${modalData.address.number} ${(modalData
        .address.complement &&
        "- " + modalData.address.complement) ||
        ""} | ${modalData.address.CEP.slice(0, 5) +
        "-" +
        modalData.address.CEP.slice(5)}`
        }}
        <h3>Contato</h3>
        <h4>Número de Telefone</h4>
        {{ modalData.contact.phone_number }}
        <h4>Número de Telefone de Emergência</h4>
        {{ modalData.contact.emergency_phone }}
        <h4>Nome do Contato de Emergência</h4>
        {{ modalData.contact.emergency_contact }}
        <h3>Divulgação</h3>
        <h4>Como ficou sabendo do evento?</h4>
        <div style="display: flex; flex-direction: column">
          <span v-for="channel in modalData.disclosure" :key="channel.code">
            {{
            channel.name
            }}
          </span>
        </div>
        <h4>Permite uso de imagem?</h4>
        {{ modalData.image_authorization ? "Sim" : "Não" }}
      </div>
    </modal>
    <div class="list">
      <div
        class="item"
        v-for="{ data, metadata } in list.slice(0, 20)"
        :key="data.id"
        :title="`${data.fullname} | ${data.document.value}`"
      >
        <span class="item-name">{{ data.fullname }}</span>
        <span class="item-doc">{{ data.document.value }}</span>
        <span class="item-buttons">
          <i
            class="material-icons"
            title="More info"
            @click="
              infoModal = true;
              modalData = data;
            "
          >info</i>
          <i class="material-icons" title="Assign new code" @click="setCode(data)">code</i>
        </span>
        <span class="item-status">
          <span class="dot" :style="`background-color: ${colorFromMetadata(metadata)}`" />
        </span>
      </div>
    </div>
  </abeuni-form>
</template>

<script>
import uuid from 'uuid/v1'
import { mapGetters, mapMutations } from 'vuex'
import AbeuniForm from './forms/AbeuniForm'
import Modal from './Modal'

export default {
  components: {
    AbeuniForm,
    Modal
  },
  data () {
    return {
      infoModal: false,
      modalData: null,
      list: [],
      config: {
        search_keys: ['data.fullname', 'data.document.value']
      }
    }
  },
  computed: {
    ...mapGetters({ registered: 'registeredList' })
  },
  methods: {
    ...mapMutations(['assignCode']),
    search (results) {
      this.list = results
    },
    colorFromMetadata (metadata) {
      if (metadata.origin !== 'local') return 'blue'

      if (metadata.uploaded) return 'green'
      else return 'red'
    },
    showInfo (data) {},
    setCode (data) {
      const code = prompt('Enter QR code value')

      if (!code) return

      if (code.length === 5 && this.verifyCode(code)) {
        this.assignCode({
          code,
          ref: data.id,
          id: uuid()
        })
      } else {
        alert('Invalid QR code!')
      }
    },
    verifyCode (code) {
      const digits = code
        .slice(0, code.length - 1)
        .split('')
        .map(dig => parseInt(dig))
      const vdigit = parseInt(code.slice(code.length - 1))

      const expected =
        digits
          .map((dig, index) => Math.pow((index + 1) * dig, 3))
          .reduce((a, b) => a + b) % 10

      return vdigit === expected
    }
  }
}
</script>

<style lang="scss" scoped>
.registered-list {
  .info-modal-content {
    padding: 1em;
  }

  .list {
    .item {
      display: grid;
      grid-template:
        "name name but  stat"
        "doc  doc  but  stat";

      grid-template-columns: auto auto 6em 20px;

      padding: 1.5em;

      cursor: pointer;
      border-radius: 5px;
    }

    .item:hover {
      background: #eee;
    }

    .item > .item-name {
      grid-area: name;

      font: 1.3em sans-serif;

      max-width: 15em;

      white-space: nowrap;
      overflow: hidden;
      text-overflow: ellipsis;
    }
    .item > .item-doc {
      grid-area: doc;

      margin-top: 5px;
    }
    .item > .item-buttons {
      i {
        border-radius: 50%;
        padding: 5px;
      }

      i:hover {
        background: #ddd;
      }

      grid-area: but;

      display: flex;
      align-items: center;

      padding: 1em;
    }
    .item > .item-status {
      grid-area: stat;

      .dot {
        height: 20px;
        width: 20px;
        border-radius: 50%;
        display: inline-block;

        margin: auto;
      }

      display: flex;
    }

    display: flex;
    flex-direction: column;

    margin-top: 2em;
  }
}
</style>
